#!/bin/bash

if [ $# -lt 2 ]
then
	echo "Syntax: ./build.sh version tag"
	exit
else
	echo > /dev/null
fi

TAG=`echo $2 | perl -pi -e 's/[-.]/__/g'`
PV=$1

mkdir release
cd release
rm -rf *
if svn co http://192.168.1.17/kbudget/repos/tags/$TAG/kbudget/
then
	true
else
	echo "SVN checkout failed"
	exit
fi

cd kbudget
find -name .svn -type d | xargs -- rm -rf
export WANT_AUTOCONF_2_5=1
make -f Makefile.dist
rm -rf autom4te*
cd ..

mv kbudget kbudget-$PV
tar -cf kbudget-$PV.tar kbudget-$PV

cd kbudget-$PV
echo doing test build...
if !(./configure --with-qt-dir=/usr/qt/3 && make && su -c 'make install')
then
	echo Build error, aborting
	exit
else
	echo Build completed successfully
fi
cd ..

cat kbudget-$PV.tar | gzip > kbudget-$PV.tar.gz
bzip2 kbudget-$PV.tar
ls -lh kbudget-$PV.tar*

md5sum kbudget-$PV.tar* > MD5SUMS-$PV.txt

