/***************************************************************************
                          ktransactionfinddlg.cpp  -  description
                             -------------------
    begin                : Thu Apr 3 2003
    copyright            : (C) 2003 by Richard Garand
    email                : richard@garandnet.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qvbox.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qpushbutton.h>

#include <kcombobox.h>
#include <klocale.h>
#include <kmainwindow.h>
#include <klineedit.h>

#include <libkdepim/kdateedit.h>

#include "ktransactionsearchdlg.h"
#include "ktransactionlist.h"
#include "account.h"
#include "kbudgetdoc.h"

class KTransactionFilter : public QHBox
{
  Q_OBJECT
  public:
    KTransactionFilter(QWidget* parent, QPtrList<Account> accounts)
      : QHBox(parent, "transaction_filter"), acct(0), text(0)
    {
      type = new KComboBox(this);
      type->insertItem(i18n("From"));
      type->insertItem(i18n("To"));
      type->insertItem(i18n("From or To"));
      type->insertItem(i18n("Description"));

      op = new KComboBox(this);
      op->insertItem(i18n("contains"));
      op->insertItem(i18n("equals"));

      accts = accounts;
      
      acct = new KComboBox(this);
      for ( accts.first(); accts.current(); accts.next ) {
//        acct.insertItem(accts.curent()->name());
      }
    }

    ~KTransactionFilter()
    {
    }

    bool matches(Transaction* tx)
    {
      return true;
    }

  public slots:
    void slotTypeChanged()
    {
      if ( type->currentItem() < 3 ) {
        
      }
    }
  
  private:
    KComboBox* type;
    KComboBox* op;
    KComboBox* acct;
    KLineEdit* text;
    QPtrList<Account> accts;
};

KTransactionFindDlg::KTransactionFindDlg(KMainWindow* parent, KBudgetDoc* doc)
  : KDialogBase(parent, "transaction_find_dialog", false, i18n("Find Transactions"),
      User1 | User2 | Close, User1, false, KGuiItem(i18n("&Search"), "find"),
      KGuiItem(i18n("&Clear"), "clear") ),
  m_doc(doc)
{
  QVBox* vb = new QVBox(this);
  setMainWidget(vb);

  QFrame* gframe = new QFrame(vb);
  QGridLayout* grid = new QGridLayout(gframe);

  QLabel* lb = new QLabel(i18n("From:"), gframe);
  grid->addWidget(lb, 0, 0);
  from = new KComboBox(gframe);
  grid->addWidget(from, 0, 1);

  lb = new QLabel(i18n("To:"), gframe);
  grid->addWidget(lb, 1, 0);
  to = new KComboBox(gframe);
  grid->addWidget(to, 1, 1);

  lb = new QLabel(i18n("Description contains:"), gframe);
  grid->addWidget(lb, 2, 0);
  desc = new KLineEdit(gframe);
  grid->addWidget(desc, 2, 1);

  QPushButton* pb = new QPushButton(i18n("Find"), gframe);
  grid->addWidget(pb, 3, 0);
  connect(pb, SIGNAL(clicked()), SLOT(slotFind()));

  accounts = doc->getAllAccounts();

  from->insertItem(i18n("<any account>"));
  to->insertItem(i18n("<any account>"));
  for ( unsigned int i = 0; i < accounts.count(); i++ ) {
    from->insertItem(accounts.at(i)->name());
    to->insertItem(accounts.current()->name());
  }

  txnList = new KTransactionList(doc, vb);
}

KTransactionFindDlg::~KTransactionFindDlg()
{
}

void KTransactionFindDlg::slotFind()
{
  txnList->clear();

  int fromItem = from->currentItem();
  int toItem = to->currentItem();
  QString d = desc->text();

  if ( !fromItem )
    fromItem = -1;
  else
    fromItem = accounts.at(fromItem - 1)->id();
  if ( !toItem )
    toItem = -1;
  else
    toItem = accounts.at(toItem - 1)->id();

  QValueVector<Transaction*> txns = m_doc->getTransactions(KPeriod());
  QValueVector<Transaction*>::iterator it;
  bool match;
  for ( it = txns.begin(); it != txns.end(); it++ ) {
    match = true;
    if ( fromItem != -1 && (*it)->from() != fromItem )
      match = false;
    if ( toItem != -1 && (*it)->to() != toItem )
      match = false;
    if ( !(*it)->description().contains(d, false) )
      match = false;
    if ( match )
      txnList->addTransaction((*it)->id());
  }
}

#include "ktransactionsearchdlg.moc"
